Subject: Re: [RFD] Layering: Use-Case Composers (was: DRBD - what is it, anyways? [compare with e.g. NBD + MD raid])

From: David Greaves <[email-masked]>
Date: Mon, 13 Aug 2007 13:43:55 +0100

[email-masked] wrote:
>> Would this just be relevant to network devices or would it improve 
>> support for jostled usb and sata hot-plugging I wonder?
> 
> good question, I suspect that some of the error handling would be 
> similar (for devices that are unreachable not haning the system for 
> example), but a lot of the rest would be different (do you really want 
> to try to auto-resync to a drive that you _think_ just reappeared,
Well, omit 'think' and the answer may be "yes". A lot of systems are quite 
simple and RAID is common on the desktop now. If jostled USB fits into this 
category - then "yes".

> what 
> if it's a different drive? how can you be sure?
And that's the key isn't it. We have the RAID device UUID and the superblock 
info. Isn't that enough? If not then given the work involved an extended 
superblock wouldn't be unreasonable.
And I suspect the capability of devices would need recording in the superblock 
too? eg 'retry-on-fail'
I can see how md would fail a device but may now periodically retry it. If a 
retry shows that it's back then it would validate it (UUID) and then resync it.

> ) the error rate of a 
> network is gong to be significantly higher then for USB or SATA drives 
> (although I suppose iscsi would be limilar)

I do agree - I was looking for value-add for the existing subsystem. If this 
benefits existing RAID users then it's more likely to be attractive.

David